ShopWebApp/Controllers/CartController.cs
using ShopWebApp.Domain.Interfaces;
using ShopWebApp.Domain.Models;
using ShopWebApp.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ShopWebApp.Controllers
{
    public class CartController : Controller
    {
        private IUnitOfWork db;


        public CartController(IUnitOfWork dbUnit)
        {
            this.db = dbUnit;
        }


        // GET: Cart
        public ActionResult Index(Cart cart, string returnUrl = null)
        {
            return View(new CartIndexViewModel { Cart = cart, ReturnUrl = returnUrl });
        }


        public ActionResult AddToCart(Cart cart, int id, string returnUrl)
        {
            var product = db.Goods.GetById(id);
            if (product != null)
            {
                cart.AddItem(product, 1);
            }

            return RedirectToAction("Index", new { returnUrl });
        }


        public ActionResult RemoveFromCart(Cart cart, int id, string returnUrl)
        {
            var itemToRemove = cart.Items.FirstOrDefault(t => t.Good.Id == id);
            if (itemToRemove != null)
                cart.RemoveItem(itemToRemove.Good);
            return RedirectToAction("Index", new { returnUrl });
        }


        public JsonResult IncreaseAmount(Cart cart, int id)
        {
            var itemToUpdate = cart.Items.FirstOrDefault(t => t.Good.Id == id);
            if (itemToUpdate != null)
                itemToUpdate.Count += 1;

            return Json(new { count = itemToUpdate.Count });
        }


        public JsonResult DecreaseAmount(Cart cart, int id)
        {
            var itemToUpdate = cart.Items.FirstOrDefault(t => t.Good.Id == id);
            if (itemToUpdate != null && itemToUpdate.Count > 1)
                itemToUpdate.Count -= 1;

            return Json(new { count = itemToUpdate.Count });
        }


        public int GetItemsCount(Cart cart)
        {
            return cart != null ? cart.Items.Count() : 0;
        }
    }
}

ShopWebApp/Controllers/ClientController.cs
using ShopWebApp.Domain.Interfaces;
using ShopWebApp.Domain.Models;
using ShopWebApp.Models;
using ShopWebApp.Utilities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace ShopWebApp.Controllers
{
    public class ClientController : Controller
    {
        private IUnitOfWork db;
        private IUoFRepository<Category> categoriesRepo;
        private IUoFRepository<Good> goodsRepo;

        public ClientController(IUnitOfWork dbUnit)
        {
            this.db = dbUnit;
            this.goodsRepo = db.Goods;
            this.categoriesRepo = db.Categories;
        }

        // GET: Goods
        [Route("", Name = "Default")]
        [Route("page{page:int}", Name = "Default/Page")]
        [Route("{category}", Name = "Default/Category")]
        [Route("{category}/page{page:int}", Name = "Default/Category/Page")]
        public ActionResult Index(
            int? page = 1, 
            int? maxResults = null, 
            GoodsFilters filters = null, 
            string category = null)
        {
            if (page == null || page < 1)
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            if (maxResults < 1)
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            
            // apply filters
            if (filters == null)
                filters = new GoodsFilters();
            var goodsList = filters.ApplyFilters(goodsRepo.GetList());

            // additional filter by category
            if (category != null)
            {
                var categoryId = categoriesRepo.GetList()
                    .Select(c => new { Id = c.Id, Name = HelperMethods.NormalizeCategoryName(c.CategoryName) })
                    .FirstOrDefault(c => String.Compare(c.Name, category, true) == 0)
                    ?.Id;

                if (categoryId.HasValue)
                {
                    filters.SelectedCategories.Add(categoryId.Value);
                    goodsList = goodsList.Where(g => g.CategoryId == categoryId);
                }
            }

            var itemsPerPage = maxResults ?? PaginationInfo.ItemsPerPageDefault;
            
            // config pagination helper
            var pageinfo = new PaginationInfo
            {
                CurrentPage = page.Value,
                ItemsCount = goodsList.Count(),
                ItemsPerPage = itemsPerPage
            };

            var goodsOnPage = goodsList
                .Skip((page.Value - 1) * itemsPerPage)
                .Take(itemsPerPage);

            // config view model
            var viewModel = new FilteredGoodsIndexViewModel
            {
                PaginationInfo = pageinfo,
                Collection = goodsOnPage,
                CategoriesList = categoriesRepo.GetList(),
                Filters = filters
            };

            return View("~/Views/Client/Index.cshtml", viewModel);
        }


        // GET: Goods/Details/5
        [Route("details/{id?}")]
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }

            Good good = goodsRepo.GetById(id.Value);

            if (good == null)
            {
                return HttpNotFound();
            }

            return View(good);
        }


        [HttpPost]
        public ActionResult ApplyFilter(int? maxResults, GoodsFilters filters)
        {
            var routeValues = new RouteValueDictionary();

            if (maxResults != null)
                routeValues.Add("maxResults", maxResults.Value);

            // serialize filter collections
            filters.SerializeCollectionFilters();
            if (filters.SelectedCategories.Count == 1)
            {
                var filterCategoryId = filters.SelectedCategories.First();
                var categoryName = categoriesRepo.GetList()
                            .First(c => c.Id == filterCategoryId)
                            .CategoryName;
                var normalizedCategoryName = HelperMethods.NormalizeCategoryName(categoryName);
                routeValues.Add("category", normalizedCategoryName);
                
                var url = Url.RouteUrl("Default/Category", routeValues);

                return Redirect(url);
            }
            else if (filters.SelectedCategories.Count > 1)
            {
                routeValues.Add("categories", filters.Categories);
            }

            return RedirectToAction(nameof(Index), routeValues);
        }
        
    }
}

ShopWebApp/Views/Shared/_Layout.cshtml
<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>@ViewBag.Title</title>
    @Styles.Render("~/Content/css")
</head>
<body>
    @Html.Partial("_SiteNavbar")

    <div class="container-lg">
        @RenderBody()
    </div>
</body>
@Scripts.Render("~/bundles/jquery")
@Scripts.Render("~/bundles/ajax")
@Scripts.Render("~/bundles/bootstrap")
@RenderSection("scripts", false)
</html>

ShopWebApp/Views/Shared/_SiteNavbar.cshtml
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
    <a class="navbar-brand" href="#">ShopApp</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-items" aria-controls="navbar-items" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbar-items">
        <ul class="navbar-nav mr-auto">
            @*Home*@
            <li class="nav-item">
                @Html.ActionLink("Home", "Index", "Client", null, new { @class = "nav-link" })
            </li>
            @*Cart*@
            <li class="nav-item" title="Shopping cart">
                <a href="@Url.Action("Index", "Cart", new { returnUrl = Request.Url.PathAndQuery })" class="nav-link position-relative">
                    <i class="fas fa-shopping-cart fa-lg"></i>
                    @{
                        var itemsInCartCount = int.Parse(Html.Action("GetItemsCount", "Cart").ToString());
                        if (itemsInCartCount > 0)
                        {
                            <span class="badge badge-pill badge-primary cart-badge">@itemsInCartCount</span>
                        }
                    }
                </a>
            </li>
            @*Admin pages*@
            <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle" href="#" id="navbar-admin-menu" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    Admin pages
                </a>
                <div class="dropdown-menu" aria-labelledby="navbar-admin-menu">
                    @Html.ActionLink("Goods", "Index", "Goods", null, new { @class = "dropdown-item" })
                    @Html.ActionLink("Categories", "Index", "Categories", null, new { @class = "dropdown-item" })
                </div>
            </li>
        </ul>

        @*search box*@
        @*@using (Html.BeginForm("Search", "Search", FormMethod.Get, new { @class = "form-inline my-2 my-lg-0" }))
        {
            <input class="form-control mr-sm-2" type="search" name="q" placeholder="Search" aria-label="Search">
            <button class="btn btn-outline-primary my-2 my-sm-0" type="submit">Search</button>
        }*@
        @using (Ajax.BeginForm("SearchAjax", "Search", null, new AjaxOptions { UpdateTargetId = "items" }, new { @class = "form-inline my-2 my-lg-0" }))
        {
            <input class="form-control mr-sm-2" type="search" name="q" placeholder="Search" aria-label="Search">
            <button class="btn btn-outline-primary my-2 my-sm-0" type="submit">Search</button>
        }
    </div>
</nav>